<?php

/**
 * This is the model class for table "sale".
 *
 * The followings are the available columns in table 'sale':
 * @property string $saleno
 * @property string $topid
 * @property string $cashid
 * @property string $tstatus
 * @property string $taxid
 * @property string $accar
 * @property string $acccash
 * @property string $termtype
 * @property string $sono
 * @property string $empid
 * @property string $accfreight
 * @property string $branchid
 * @property string $canvasid
 * @property string $srepid
 * @property string $accsdisc
 * @property string $saletype
 * @property string $posid
 * @property string $custid
 * @property string $reftype
 * @property string $whid
 * @property string $refrid
 * @property string $perid
 * @property string $crcid
 * @property string $possesno
 * @property string $fobid
 * @property string $shipid
 * @property string $saleno2
 * @property string $saledate
 * @property string $custpono
 * @property string $docno
 * @property string $taxsaleno
 * @property string $taxsaledate
 * @property string $pph23saleno
 * @property string $pph23saledate
 * @property string $billto
 * @property string $shipto
 * @property integer $duedays
 * @property integer $discdays
 * @property string $earlydisc
 * @property string $latecharge
 * @property string $shipdtime
 * @property string $shipstatus
 * @property boolean $istaxed
 * @property boolean $taxinc
 * @property string $excrate
 * @property string $fisrate
 * @property string $costtot
 * @property string $subtotal
 * @property string $discexp
 * @property string $discamt
 * @property string $taxamt
 * @property string $freight
 * @property string $others
 * @property string $total
 * @property string $dpayment
 * @property string $paidamt
 * @property string $salenote
 * @property string $salestatus
 * @property string $paystatus
 * @property boolean $isautogen
 * @property string $refno
 * @property string $chkby
 * @property string $aprby
 * @property string $crtby
 * @property string $crtdate
 * @property string $updby
 * @property string $upddate
 * @property string $syncdate
 * @property boolean $_xt
 * @property boolean $islocked
 * @property string $consno
 * @property boolean $isdraft
 * @property boolean $isposted
 * @property string $accloss
 * @property string $basesubtotal
 * @property string $basetaxamt
 * @property string $basediscamt
 * @property string $basetotal
 * @property string $basftaxamt
 * @property boolean $isimport
 * @property string $settledate
 * @property string $version
 * @property boolean $ismemorized
 * @property boolean $isrecurring
 * @property string $recurno
 * @property integer $recurdno
 * @property string $memorizednote
 * @property string $printcount
 *
 * The followings are the available model relations:
 * @property Bill[] $bills
 * @property Cons[] $cons
 * @property Deli[] $delis
 * @property Saled[] $saleds
 * @property Salecrcv[] $salecrcvs
 * @property Salebns[] $salebns
 * @property Saledfa[] $saledfas
 * @property So[] $sos
 * @property Sret[] $srets
 * @property Acc $acccash0
 * @property Acc $accfreight0
 * @property Acc $accsdisc0
 * @property Branch $branch
 * @property Canvas $canvas
 * @property Cash $cash
 * @property Crc $crc
 * @property Emp $emp
 * @property Fob $fob
 * @property Per $per
 * @property Pos $pos
 * @property Posses $possesno0
 * @property Reftype $reftype0
 * @property Saletype $saletype0
 * @property Ship $ship
 * @property So $sono0
 * @property Srep $srep
 * @property Tax $tax
 * @property Termtype $termtype0
 * @property Top $top
 * @property Tstatus $tstatus0
 * @property Wh $wh
 * @property Bp $cust
 * @property Bp $refr
 * @property Acc $accar0
 * @property Acc $accloss0
 */
class Sale extends CActiveRecord
{
	/**
	 * Returns the static model of the specified AR class.
	 * @param string $className active record class name.
	 * @return Sale the static model class
	 */
	public static function model($className=__CLASS__)
	{
		return parent::model($className);
	}

	/**
	 * @return string the associated database table name
	 */
	public function tableName()
	{
		return 'sale';
	}

	/**
	 * @return array validation rules for model attributes.
	 */
	public function rules()
	{
		// NOTE: you should only define rules for those attributes that
		// will receive user inputs.
		return array(
			array('saleno', 'required'),
			array('duedays, discdays, recurdno', 'numerical', 'integerOnly'=>true),
			array('saleno, cashid, sono, empid, custid, refrid, saleno2, earlydisc, latecharge, discexp, refno, consno, recurno', 'length', 'max'=>15),
			array('topid, taxid, branchid, canvasid, saletype, posid, reftype, perid, crcid, fobid', 'length', 'max'=>5),
			array('tstatus, termtype, shipstatus, paystatus', 'length', 'max'=>1),
			array('accar, acccash, accfreight, srepid, accsdisc, shipid, chkby, aprby, crtby, updby, accloss', 'length', 'max'=>10),
			array('whid', 'length', 'max'=>3),
			array('possesno', 'length', 'max'=>8),
			array('custpono, docno, taxsaleno', 'length', 'max'=>20),
			array('pph23saleno', 'length', 'max'=>50),
			array('excrate, fisrate, costtot, subtotal, discamt, taxamt, freight, others, total, dpayment, paidamt, basesubtotal, basetaxamt, basediscamt, basetotal, basftaxamt', 'length', 'max'=>19),
			array('salestatus', 'length', 'max'=>2),
			array('saledate, taxsaledate, pph23saledate, billto, shipto, shipdtime, istaxed, taxinc, salenote, isautogen, crtdate, upddate, syncdate, _xt, islocked, isdraft, isposted, isimport, settledate, version, ismemorized, isrecurring, memorizednote, printcount', 'safe'),
			// The following rule is used by search().
			// Please remove those attributes that should not be searched.
			array('saleno, topid, cashid, tstatus, taxid, accar, acccash, termtype, sono, empid, accfreight, branchid, canvasid, srepid, accsdisc, saletype, posid, custid, reftype, whid, refrid, perid, crcid, possesno, fobid, shipid, saleno2, saledate, custpono, docno, taxsaleno, taxsaledate, pph23saleno, pph23saledate, billto, shipto, duedays, discdays, earlydisc, latecharge, shipdtime, shipstatus, istaxed, taxinc, excrate, fisrate, costtot, subtotal, discexp, discamt, taxamt, freight, others, total, dpayment, paidamt, salenote, salestatus, paystatus, isautogen, refno, chkby, aprby, crtby, crtdate, updby, upddate, syncdate, _xt, islocked, consno, isdraft, isposted, accloss, basesubtotal, basetaxamt, basediscamt, basetotal, basftaxamt, isimport, settledate, version, ismemorized, isrecurring, recurno, recurdno, memorizednote, printcount', 'safe', 'on'=>'search'),
		);
	}

	/**
	 * @return array relational rules.
	 */
	public function relations()
	{
		// NOTE: you may need to adjust the relation name and the related
		// class name for the relations automatically generated below.
		return array(
			'bills' => array(self::MANY_MANY, 'Bill', 'billsale(saleno, billno)'),
			'cons' => array(self::MANY_MANY, 'Cons', 'conssale(saleno, consno)'),
			'delis' => array(self::MANY_MANY, 'Deli', 'delisale(saleno, delino)'),
			'saleds' => array(self::HAS_MANY, 'Saled', 'saleno'),
			'salecrcvs' => array(self::HAS_MANY, 'Salecrcv', 'saleno'),
			'salebns' => array(self::HAS_MANY, 'Salebns', 'saleno'),
			'saledfas' => array(self::HAS_MANY, 'Saledfa', 'saleno'),
			'sos' => array(self::MANY_MANY, 'So', 'sosale(saleno, sono)'),
			'srets' => array(self::HAS_MANY, 'Sret', 'saleno'),
			'acccash0' => array(self::BELONGS_TO, 'Acc', 'acccash'),
			'accfreight0' => array(self::BELONGS_TO, 'Acc', 'accfreight'),
			'accsdisc0' => array(self::BELONGS_TO, 'Acc', 'accsdisc'),
			'branch' => array(self::BELONGS_TO, 'Branch', 'branchid'),
			'canvas' => array(self::BELONGS_TO, 'Canvas', 'canvasid'),
			'cash' => array(self::BELONGS_TO, 'Cash', 'cashid'),
			'crc' => array(self::BELONGS_TO, 'Crc', 'crcid'),
			'emp' => array(self::BELONGS_TO, 'Emp', 'empid'),
			'fob' => array(self::BELONGS_TO, 'Fob', 'fobid'),
			'per' => array(self::BELONGS_TO, 'Per', 'perid'),
			'pos' => array(self::BELONGS_TO, 'Pos', 'posid'),
			'possesno0' => array(self::BELONGS_TO, 'Posses', 'possesno'),
			'reftype0' => array(self::BELONGS_TO, 'Reftype', 'reftype'),
			'saletype0' => array(self::BELONGS_TO, 'Saletype', 'saletype'),
			'ship' => array(self::BELONGS_TO, 'Ship', 'shipid'),
			'sono0' => array(self::BELONGS_TO, 'So', 'sono'),
			'srep' => array(self::BELONGS_TO, 'Srep', 'srepid'),
			'tax' => array(self::BELONGS_TO, 'Tax', 'taxid'),
			'termtype0' => array(self::BELONGS_TO, 'Termtype', 'termtype'),
			'top' => array(self::BELONGS_TO, 'Top', 'topid'),
			'tstatus0' => array(self::BELONGS_TO, 'Tstatus', 'tstatus'),
			'wh' => array(self::BELONGS_TO, 'Wh', 'whid'),
			'cust' => array(self::BELONGS_TO, 'Bp', 'custid'),
			'refr' => array(self::BELONGS_TO, 'Bp', 'refrid'),
			'accar0' => array(self::BELONGS_TO, 'Acc', 'accar'),
			'accloss0' => array(self::BELONGS_TO, 'Acc', 'accloss'),
		);
	}

	/**
	 * @return array customized attribute labels (name=>label)
	 */
	public function attributeLabels()
	{
		return array(
			'saleno' => Yii::t('sale', 'saleno'),
			'topid' => Yii::t('sale', 'topid'),
			'cashid' => Yii::t('sale', 'cashid'),
			'tstatus' => Yii::t('sale', 'tstatus'),
			'taxid' => Yii::t('sale', 'taxid'),
			'accar' => Yii::t('sale', 'accar'),
			'acccash' => Yii::t('sale', 'acccash'),
			'termtype' => Yii::t('sale', 'termtype'),
			'sono' => Yii::t('sale', 'sono'),
			'empid' => Yii::t('sale', 'empid'),
			'accfreight' => Yii::t('sale', 'accfreight'),
			'branchid' => Yii::t('sale', 'branchid'),
			'canvasid' => Yii::t('sale', 'canvasid'),
			'srepid' => Yii::t('sale', 'srepid'),
			'accsdisc' => Yii::t('sale', 'accsdisc'),
			'saletype' => Yii::t('sale', 'saletype'),
			'posid' => Yii::t('sale', 'posid'),
			'custid' => Yii::t('sale', 'custid'),
			'reftype' => Yii::t('sale', 'reftype'),
			'whid' => Yii::t('sale', 'whid'),
			'refrid' => Yii::t('sale', 'refrid'),
			'perid' => Yii::t('sale', 'perid'),
			'crcid' => Yii::t('sale', 'crcid'),
			'possesno' => Yii::t('sale', 'possesno'),
			'fobid' => Yii::t('sale', 'fobid'),
			'shipid' => Yii::t('sale', 'shipid'),
			'saleno2' => Yii::t('sale', 'saleno2'),
			'saledate' => Yii::t('sale', 'saledate'),
			'custpono' => Yii::t('sale', 'custpono'),
			'docno' => Yii::t('sale', 'docno'),
			'taxsaleno' => Yii::t('sale', 'taxsaleno'),
			'taxsaledate' => Yii::t('sale', 'taxsaledate'),
			'pph23saleno' => Yii::t('sale', 'pph23saleno'),
			'pph23saledate' => Yii::t('sale', 'pph23saledate'),
			'billto' => Yii::t('sale', 'billto'),
			'shipto' => Yii::t('sale', 'shipto'),
			'duedays' => Yii::t('sale', 'duedays'),
			'discdays' => Yii::t('sale', 'discdays'),
			'earlydisc' => Yii::t('sale', 'earlydisc'),
			'latecharge' => Yii::t('sale', 'latecharge'),
			'shipdtime' => Yii::t('sale', 'shipdtime'),
			'shipstatus' => Yii::t('sale', 'shipstatus'),
			'istaxed' => Yii::t('sale', 'istaxed'),
			'taxinc' => Yii::t('sale', 'taxinc'),
			'excrate' => Yii::t('sale', 'excrate'),
			'fisrate' => Yii::t('sale', 'fisrate'),
			'costtot' => Yii::t('sale', 'costtot'),
			'subtotal' => Yii::t('sale', 'subtotal'),
			'discexp' => Yii::t('sale', 'discexp'),
			'discamt' => Yii::t('sale', 'discamt'),
			'taxamt' => Yii::t('sale', 'taxamt'),
			'freight' => Yii::t('sale', 'freight'),
			'others' => Yii::t('sale', 'others'),
			'total' => Yii::t('sale', 'total'),
			'dpayment' => Yii::t('sale', 'dpayment'),
			'paidamt' => Yii::t('sale', 'paidamt'),
			'salenote' => Yii::t('sale', 'salenote'),
			'salestatus' => Yii::t('sale', 'salestatus'),
			'paystatus' => Yii::t('sale', 'paystatus'),
			'isautogen' => Yii::t('sale', 'isautogen'),
			'refno' => Yii::t('sale', 'refno'),
			'chkby' => Yii::t('sale', 'chkby'),
			'aprby' => Yii::t('sale', 'aprby'),
			'crtby' => Yii::t('sale', 'crtby'),
			'crtdate' => Yii::t('sale', 'crtdate'),
			'updby' => Yii::t('sale', 'updby'),
			'upddate' => Yii::t('sale', 'upddate'),
			'syncdate' => Yii::t('sale', 'syncdate'),
			'_xt' => Yii::t('sale', '_xt'),
			'islocked' => Yii::t('sale', 'islocked'),
			'consno' => Yii::t('sale', 'consno'),
			'isdraft' => Yii::t('sale', 'isdraft'),
			'isposted' => Yii::t('sale', 'isposted'),
			'accloss' => Yii::t('sale', 'accloss'),
			'basesubtotal' => Yii::t('sale', 'basesubtotal'),
			'basetaxamt' => Yii::t('sale', 'basetaxamt'),
			'basediscamt' => Yii::t('sale', 'basediscamt'),
			'basetotal' => Yii::t('sale', 'basetotal'),
			'basftaxamt' => Yii::t('sale', 'basftaxamt'),
			'isimport' => Yii::t('sale', 'isimport'),
			'settledate' => Yii::t('sale', 'settledate'),
			'version' => Yii::t('sale', 'version'),
			'ismemorized' => Yii::t('sale', 'ismemorized'),
			'isrecurring' => Yii::t('sale', 'isrecurring'),
			'recurno' => Yii::t('sale', 'recurno'),
			'recurdno' => Yii::t('sale', 'recurdno'),
			'memorizednote' => Yii::t('sale', 'memorizednote'),
			'printcount' => Yii::t('sale', 'printcount'),
		);
	}

	/**
	 * Retrieves a list of models based on the current search/filter conditions.
	 * @return CActiveDataProvider the data provider that can return the models based on the search/filter conditions.
	 */
	public function search()
	{
		// Warning: Please modify the following code to remove attributes that
		// should not be searched.

		$criteria=new CDbCriteria;

		$criteria->compare('saleno',$this->saleno,true);
		$criteria->compare('topid',$this->topid,true);
		$criteria->compare('cashid',$this->cashid,true);
		$criteria->compare('tstatus',$this->tstatus,true);
		$criteria->compare('taxid',$this->taxid,true);
		$criteria->compare('accar',$this->accar,true);
		$criteria->compare('acccash',$this->acccash,true);
		$criteria->compare('termtype',$this->termtype,true);
		$criteria->compare('sono',$this->sono,true);
		$criteria->compare('empid',$this->empid,true);
		$criteria->compare('accfreight',$this->accfreight,true);
		$criteria->compare('branchid',$this->branchid,true);
		$criteria->compare('canvasid',$this->canvasid,true);
		$criteria->compare('srepid',$this->srepid,true);
		$criteria->compare('accsdisc',$this->accsdisc,true);
		$criteria->compare('saletype',$this->saletype,true);
		$criteria->compare('posid',$this->posid,true);
		$criteria->compare('custid',$this->custid,true);
		$criteria->compare('reftype',$this->reftype,true);
		$criteria->compare('whid',$this->whid,true);
		$criteria->compare('refrid',$this->refrid,true);
		$criteria->compare('perid',$this->perid,true);
		$criteria->compare('crcid',$this->crcid,true);
		$criteria->compare('possesno',$this->possesno,true);
		$criteria->compare('fobid',$this->fobid,true);
		$criteria->compare('shipid',$this->shipid,true);
		$criteria->compare('saleno2',$this->saleno2,true);
		$criteria->compare('saledate',$this->saledate,true);
		$criteria->compare('custpono',$this->custpono,true);
		$criteria->compare('docno',$this->docno,true);
		$criteria->compare('taxsaleno',$this->taxsaleno,true);
		$criteria->compare('taxsaledate',$this->taxsaledate,true);
		$criteria->compare('pph23saleno',$this->pph23saleno,true);
		$criteria->compare('pph23saledate',$this->pph23saledate,true);
		$criteria->compare('billto',$this->billto,true);
		$criteria->compare('shipto',$this->shipto,true);
		$criteria->compare('duedays',$this->duedays);
		$criteria->compare('discdays',$this->discdays);
		$criteria->compare('earlydisc',$this->earlydisc,true);
		$criteria->compare('latecharge',$this->latecharge,true);
		$criteria->compare('shipdtime',$this->shipdtime,true);
		$criteria->compare('shipstatus',$this->shipstatus,true);
		$criteria->compare('istaxed',$this->istaxed);
		$criteria->compare('taxinc',$this->taxinc);
		$criteria->compare('excrate',$this->excrate,true);
		$criteria->compare('fisrate',$this->fisrate,true);
		$criteria->compare('costtot',$this->costtot,true);
		$criteria->compare('subtotal',$this->subtotal,true);
		$criteria->compare('discexp',$this->discexp,true);
		$criteria->compare('discamt',$this->discamt,true);
		$criteria->compare('taxamt',$this->taxamt,true);
		$criteria->compare('freight',$this->freight,true);
		$criteria->compare('others',$this->others,true);
		$criteria->compare('total',$this->total,true);
		$criteria->compare('dpayment',$this->dpayment,true);
		$criteria->compare('paidamt',$this->paidamt,true);
		$criteria->compare('salenote',$this->salenote,true);
		$criteria->compare('salestatus',$this->salestatus,true);
		$criteria->compare('paystatus',$this->paystatus,true);
		$criteria->compare('isautogen',$this->isautogen);
		$criteria->compare('refno',$this->refno,true);
		$criteria->compare('chkby',$this->chkby,true);
		$criteria->compare('aprby',$this->aprby,true);
		$criteria->compare('crtby',$this->crtby,true);
		$criteria->compare('crtdate',$this->crtdate,true);
		$criteria->compare('updby',$this->updby,true);
		$criteria->compare('upddate',$this->upddate,true);
		$criteria->compare('syncdate',$this->syncdate,true);
		$criteria->compare('_xt',$this->_xt);
		$criteria->compare('islocked',$this->islocked);
		$criteria->compare('consno',$this->consno,true);
		$criteria->compare('isdraft',$this->isdraft);
		$criteria->compare('isposted',$this->isposted);
		$criteria->compare('accloss',$this->accloss,true);
		$criteria->compare('basesubtotal',$this->basesubtotal,true);
		$criteria->compare('basetaxamt',$this->basetaxamt,true);
		$criteria->compare('basediscamt',$this->basediscamt,true);
		$criteria->compare('basetotal',$this->basetotal,true);
		$criteria->compare('basftaxamt',$this->basftaxamt,true);
		$criteria->compare('isimport',$this->isimport);
		$criteria->compare('settledate',$this->settledate,true);
		$criteria->compare('version',$this->version,true);
		$criteria->compare('ismemorized',$this->ismemorized);
		$criteria->compare('isrecurring',$this->isrecurring);
		$criteria->compare('recurno',$this->recurno,true);
		$criteria->compare('recurdno',$this->recurdno);
		$criteria->compare('memorizednote',$this->memorizednote,true);
		$criteria->compare('printcount',$this->printcount,true);

		return new CActiveDataProvider($this, array(
			'criteria'=>$criteria,
		));
	}
}